<template>
  <div class="vertical-menu-panel flex-grow-0 flex-column" v-bind:class="displayClass">
    <div class="bg-primary d-flex flex-row py-3">
      <h1 class="text-light my-0 py-2 px-3 flex-grow-1">
        <span class="mr-2">
          <font-awesome-icon icon="map-marker"></font-awesome-icon>
        </span>
        {{ title }}
      </h1>
      <button class="btn text-light flex-grow-0 mr-2 close-btn" @click="close">
        <font-awesome-icon icon="times"></font-awesome-icon>
      </button>
    </div>

    <div class="d-flex flex-grow-1 flex-row">
      <div class="location-group-list d-flex flex-grow-1 flex-column bg-light">
        <div v-for="group in locationGroups" :key="createUniqueId(group)">
          <button class="btn btn-light btn-block text-left"
            :class="isActiveGroup(group.id)"
            @click="currentGroup = group.id">
            {{ group.title }}
          </button>
        </div>
      </div>
      <div class="location-list d-flex flex-grow-1 flex-column px-2 py-2">
        <location-checkbox v-for="location in currentLocations" :key="createUniqueId(location)"
          :location="location.id">
        </location-checkbox>
      </div>
    </div>
  </div>
</template>

<script>
import { createUniqueId } from '@/core/util'
// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

// Store
import { CHANGE_PANEL, mutationNameResolve } from '@/store/workspace/mutations'

// Components
import LocationCheckbox from './LocationCheckbox'

export default {
  name: 'locationverticalpanel',

  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    title: {
      type: String,
      default: 'Camadas'
    },
    name: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      currentGroup: 0,
    }
  },

  computed: {
    currentPanel: {
      get() {
        return this.$store.state[this.workspace].currentPanel
      }
    },

    locationGroups: {
      get() {
        return this.$store.state.locationGroups
      }
    },

    locations: {
      get() {
        return this.$store.state.locations
      }
    },

    currentLocations: {
      get() {
        return this.locations.filter((loc) => {
          return this.isLocationInCurrentGroup(loc)
        })
      },
    },

    displayClass: {
      get() {
        return this.currentPanel === this.name ? 'd-flex' : 'd-none'
      }
    },
  },

  methods: {
    close() {
      this.$store.commit(mutationNameResolve(this.workspace, CHANGE_PANEL), { panel: this.name })
    },

    isActiveGroup(group) {
      return {
        active: group === this.currentGroup,
      }
    },

    isLocationInCurrentGroup(loc) {
      return loc.groups.includes(this.currentGroup)
    },

    createUniqueId() {
      return createUniqueId()
    },
  },

  mounted() {
    this.currentGroup = this.locationGroups[0].id
  },

  components: {
    LocationCheckbox,
  },

}
</script>

<style scoped>
.vertical-menu-panel {
  font-size: 0.8em;
  line-height: 1.8em;
}

.vertical-menu-panel h1 {
  font-weight: lighter;
}

.vertical-menu-panel button.btn.close-btn {
  border-radius: 2rem;
  height: max-content;
  width: max-content;
  margin-top: auto;
  margin-bottom: auto;
}

.vertical-menu-panel button.btn.close-btn:hover {
  background-color: #008eff !important;
}

.location-group-list {
  min-width: 10rem !important;
}

.location-list {
  min-width: 15rem !important;
}

.location-group-list button.btn {
  border-radius: 0;
}
</style>
